| profit

## Function

Scan a sequence or database with a matrix or profile

## Description

profit takes a simple frequency matrix produced by prophecy and searches with this to find matches in the input sequence(s) you are searching.

Scores for the matches are calculated from the simple frequency matrix. It is the sum of scores at each position of the matrix.

A 'simple frequency matrix' is simply a count of the number of times any particular amino acid occurs at each position in the alignment used to create it. Simple frequency matrices are created using the program prophecy with the option '-type F' to create the correct type of matrix. The alignment should not have gaps in it.

The resulting matrix is moved to each position in the sequence(s) you are searching. At each position in the sequence, the frequencies of the amino acids or bases covered by the length of the matrix is read from the matrix. The sum of these frequencies at each position of the matrix is the score for that position of the sequence. If this score is above the threshold percentage of the maximum possible score for that matrix, then a hit is reported.

## Usage

Before running the example, we need to make a simple frequency matrix using prophecy

This is the ungapped aligned set of sequences used to make the matrix:

    % more m.seq
    >one
    DEVGGEALGRLLVVYPWTQR
    >two
    DEVGREALGRLLVVYPWTQR
    >three
    DEVGGEALGRILVVYPWTQR
    >four
    DEVGGEAAGRVLVVYPWTQR

    % prophecy
    Creates matrices/profiles from multiple alignments
    Input sequence set: m.seq
    Profile type
             F : Frequency
             G : Gribskov
             H : Henikoff
    Select type [F]:
    Enter a name for the profile [mymatrix]:
    Enter threshold reporting percentage [75]:
    Output file [outfile.prophecy]:

Here is a sample session with profit

    % profit
    Scan a sequence or database with a matrix or profile
    Profile or weight matrix file: outfile.prophecy
    Input sequence(s): tsw:*
    Output file [outfile.profit]:

Go to the input files for this example
Go to the output files for this example

## Command line arguments

       Standard (Mandatory) qualifiers:
      [-infile]            infile     Profile or weight matrix file
      [-sequence]          seqall     Sequence(s) filename and optional format, or
                                      reference (input USA)
      [-outfile]           outfile    [*.profit] Output file name

       Additional (Optional) qualifiers: (none)
       Advanced (Unprompted) qualifiers: (none)
       Associated qualifiers:

       "-sequence" associated qualifiers
       -sbegin2            integer    Start of each sequence to be used
       -send2              integer    End of each sequence to be used
       -sreverse2          boolean    Reverse (if DNA)
       -sask2              boolean    Ask for begin/end/reverse
       -snucleotide2       boolean    Sequence is nucleotide
       -sprotein2          boolean    Sequence is protein
       -slower2            boolean    Make lower case
       -supper2            boolean    Make upper case
       -sformat2           string     Input sequence format
       -sdbname2           string     Database name
       -sid2               string     Entryname
       -ufo2               string     UFO features
       -fformat2           string     Features format
       -fopenfile2         string     Features file name

       "-outfile" associated qualifiers
       -odirectory3        string     Output directory

       General qualifiers:
       -auto               boolean    Turn off prompts
       -stdout             boolean    Write standard output
       -filter             boolean    Read standard input, write standard output
       -options            boolean    Prompt for standard and additional values
       -debug              boolean    Write debug output to program.dbg
       -verbose            boolean    Report some/full command line options
       -help               boolean    Report command line options. More
                                      information on associated and general
                                      qualifiers can be found with -help -verbose
       -warning            boolean    Report warnings
       -error              boolean    Report errors
       -fatal              boolean    Report fatal errors
       -die                boolean    Report dying program messages

Standard (Mandatory) qualifiers | Allowed values | Default
--- | --- | ---
[-infile] (Parameter 1) | Profile or weight matrix file | Input file | Required
[-sequence] (Parameter 2) | Sequence(s) filename and optional format, or reference (input USA) | Readable sequence(s) | Required
[-outfile] (Parameter 3) | Output file name | Output file | <*>.profit
Additional (Optional) qualifiers | Allowed values | Default
(none)
Advanced (Unprompted) qualifiers | Allowed values | Default
(none)

## Input file format

profit reads a simple frequency matrix produced by prophecy and uses it to search searches one or more protein or nucleic acid sequence USAs.

### Input files for usage example

'tsw:*' is a sequence entry in the example protein database 'tsw'

### File: outfile.prophecy

    # Pure Frequency Matrix
    # Columns are amino acid counts A->Z
    # Rows are alignment positions 1->n
    Simple
    Name		mymatrix
    Length		20
    Maximum score	76
    Thresh		75
    Consensus	DEVGGEALGRLLVVYPWTQR
    0  0  0  4  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
    0  0  0  0  4  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
    0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  4  0  0  0  0  0
    0  0  0  0  0  0  4  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
    0  0  0  0  0  0  3  0  0  0  0  0  0  0  0  0  0  1  0  0  0  0  0  0  0  0  0
    0  0  0  0  4  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
    4  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
    1  0  0  0  0  0  0  0  0  0  0  3  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
    0  0  0  0  0  0  4  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
    0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  4  0  0  0  0  0  0  0  0  0
    0  0  0  0  0  0  0  0  1  0  0  2  0  0  0  0  0  0  0  0  0  1  0  0  0  0  0
    0  0  0  0  0  0  0  0  0  0  0  4  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
    0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  4  0  0  0  0  0
    0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  4  0  0  0  0  0
    0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  4  0  0
    0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  4  0  0  0  0  0  0  0  0  0  0  0
    0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  4  0  0  0  0
    0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  4  0  0  0  0  0  0  0
    0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  4  0  0  0  0  0  0  0  0  0  0
    0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  4  0  0  0  0  0  0  0  0  0

## Output file format

### Output files for usage example

### File: outfile.profit

    # PROF scan using simple frequency matrix mymatrix
    # Scores >= threshold 75 (max score 76)
    #
    HBB_HUMAN 22 Percentage: 100
    HBB_PANPA 22 Percentage: 100
    HBB_PANTR 22 Percentage: 100

The ouput is a list of three columns.

The first column is the name of the matching sequence found.
The second is the start position in the sequence of the match.
The third column (after the word 'Percentage:') is the percentage of the maximum possible score (sum of the highest value at each position in the frequency matrix).

## Data files

None.

## Notes

None.

## References

None.

## Warnings

The aligned set of sequences used to make the simple frquency matrix should not have gaps in it. profit will let you use a matrix made from a gapped alignment, but the results will probably not be sensible.

## Diagnostic Error Messages

None.

## Exit status

It always exits with a status of 0.

## Known bugs

None.

## See also

Program name | Description
--- | ---
prophecy | Creates matrices/profiles from multiple alignments
prophet | Gapped alignment for profiles

## Author(s)

Alan Bleasby (ajb © ebi.ac.uk)
European Bioinformatics Institute, Wellcome Trust Genome Campus, Hinxton, Cambridge CB10 1SD, UK

## History

Written (1999) - Alan Bleasby

## Target users

This program is intended to be used by everyone and everything, from naive users to embedded scripts.

## Comments

None